package com.tzld.longarticle.recommend.server.repository.crawler;

import com.tzld.longarticle.recommend.server.repository.entity.crawler.ArticleUserGroupNew;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ArticleUserGroupRepository extends JpaRepository<ArticleUserGroupNew, Long> {
    @Query("select distinct userGroupId from ArticleUserGroupNew where gzhId = :gzhId and isDelete = 0")
    List<Integer> findAllUserGroupId(String gzhId);

    ArticleUserGroupNew findFirstByGzhIdAndOpenId(String gzhId, String openId);

    @Query("select distinct openId from ArticleUserGroupNew where gzhId = :gzhId" +
            " and userGroupId = :userGroupId and isDelete = 0")
    List<String> findAllOpenId(String gzhId, int userGroupId);

    @Modifying
    @Query("UPDATE ArticleUserGroupNew a SET a.userGroupId = a.id % :groupNum WHERE a.gzhId = :gzhId")
    void updateUserGroupIdWithMod(@Param("gzhId") String gzhId, @Param("groupNum") int groupNum);
}